org.apache.ignite.internal.processors.cache.persistence

## Class AbstractCorruptedPersistenceException

- java.lang.Object
- - java.lang.Throwable
  - - java.lang.Exception
    - - org.apache.ignite.IgniteCheckedException
      - - org.apache.ignite.internal.processors.cache.persistence.AbstractCorruptedPersistenceException

All Implemented Interfaces:
  Serializable, CorruptedPersistenceException

Direct Known Subclasses:
  CorruptedFreeListException, CorruptedPartitionMetaPageException, CorruptedTreeException

    public abstract class AbstractCorruptedPersistenceException
    extends IgniteCheckedException
    implements CorruptedPersistenceException

Abstract exception for exceptions related to persistence corruption.

See Also:
  Serialized Form

### Field Summary

Fields
`protected T2<Integer,Long>[]` `pages`

### Constructor Summary

Constructors
`protected` `AbstractCorruptedPersistenceException(String msg, @Nullable Throwable cause, T2<Integer,Long>[] pages)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`protected T2<Integer,Long>[]` `expandPagesArray(T2<Integer,Long>[] pages, Throwable cause)` Add partition meta pages and related pages.
`T2<Integer,Long>[]` `pages()`
`protected Set<T2<Integer,Long>>` `partitionMetaPages(Set<T2<Integer,Long>> pages)`
`protected static T2<Integer,Long>[]` `toPagesArray(int grpId, long[] pageIds)`

### Methods inherited from class org.apache.ignite.IgniteCheckedException

`getCause, hasCause, toString`

### Methods inherited from class java.lang.Throwable

`addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### pages

    protected final T2<Integer,Long>[] pages

### Constructor Detail

#### AbstractCorruptedPersistenceException

    protected AbstractCorruptedPersistenceException(String msg,
                                                    @Nullable
                                                    @Nullable Throwable cause,
                                                    T2<Integer,Long>[] pages)

Parameters:
  `msg` - Message.
  `cause` - Cause.
  `pages` - (groupId, pageId) pairs for pages that might be corrupted.

### Method Detail

#### toPagesArray

    protected static T2<Integer,Long>[] toPagesArray(int grpId,
                                                     long[] pageIds)

Parameters:
  `grpId` - Group id.
  `pageIds` - Pages ids.
Returns:
  Pairs of (groupId, pageId).

#### expandPagesArray

    protected T2<Integer,Long>[] expandPagesArray(T2<Integer,Long>[] pages,
                                                  Throwable cause)

Add partition meta pages and related pages.

Parameters:
  `pages` - Pages with group ids.
  `cause` - Cause exception.
Returns:
  Extended list of pages.

#### partitionMetaPages

    protected Set<T2<Integer,Long>> partitionMetaPages(Set<T2<Integer,Long>> pages)

Parameters:
  `pages` - Pages with group ids.
Returns:
  Partition meta pages with group ids, for given pages.

#### pages

    public T2<Integer,Long>[] pages()

Specified by:
  `pages` in interface `CorruptedPersistenceException`
Returns:
  (groupId, pageId) pairs for pages that might be corrupted.

${current.year} Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Database and Caching Platform | : ver. 2.12.0
Release Date | : January 10 2022